import pytest

from endpoints.api.superuser import SuperUserList
from endpoints.api.test.shared import conduct_api_call
from endpoints.test.shared import client_with_identity
from test.fixtures import *

@pytest.mark.parametrize('disabled', [
  (True),
  (False),
])
def test_list_all_users(disabled, client):
  with client_with_identity('devtable', client) as cl:
    params = {'disabled': disabled}
    result = conduct_api_call(cl, SuperUserList, 'GET', params, None, 200).json
    assert len(result['users'])
    for user in result['users']:
      if not disabled:
        assert user['enabled']
